﻿using System;
using System.Threading;
using System.Drawing;

namespace WindowsFormsApplication2
{
    public class LongRunningTask
    {
        public Thread LongRunningTaskThread;

        public event EventHandler Complete;

        public LongRunningTask()
        {
        }

        public void CreateFonts()
        {
            // time-consuming operation
            for (int i = 0; i < 400000; i++)
            {
                Font f = new Font("Arial", 12.0f ,FontStyle.Strikeout);
            }

            // determine if the object on which this delegate was invoked is a UI thread   
            // if the object is a control, then the object is a UI thread   
            if (this.Complete.Target is System.Windows.Forms.Control)
            {
                // make sure execution is done on the UI thread   
                System.Windows.Forms.Control target = Complete.Target as System.Windows.Forms.Control;
                target.BeginInvoke(this.Complete, new Object[] { });
            }
            else
                // object from the invocation list isn't a UI thread.    
                this.Complete(this, EventArgs.Empty);
        }

        public void StartLongRunningTask()
        {
            LongRunningTaskThread = new Thread(new ThreadStart(this.CreateFonts));
            this.LongRunningTaskThread.Start();
        }
    }
}
